OneMergeWrappingMergePolicy (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.index, class: OneMergeWrappingMergePolicy

Package org.apache.lucene.index

# Class OneMergeWrappingMergePolicy

java.lang.Object
org.apache.lucene.index.MergePolicy
org.apache.lucene.index.FilterMergePolicy
org.apache.lucene.index.OneMergeWrappingMergePolicy

All Implemented Interfaces:
  `Unwrappable<MergePolicy>`

Direct Known Subclasses:
  `SoftDeletesRetentionMergePolicy`

public class OneMergeWrappingMergePolicy extends FilterMergePolicy
A wrapping merge policy that wraps the `MergePolicy.OneMerge` objects returned by the wrapped merge policy.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.index.MergePolicy

  `MergePolicy.MergeAbortedException, MergePolicy.MergeContext, MergePolicy.MergeException, MergePolicy.MergeObserver, MergePolicy.MergeSpecification, MergePolicy.OneMerge, MergePolicy.OneMergeProgress`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.index.FilterMergePolicy

  `in`

  ### Fields inherited from class org.apache.lucene.index.MergePolicy

  `DEFAULT_MAX_CFS_SEGMENT_SIZE, DEFAULT_NO_CFS_RATIO, maxCFSSegmentSize, noCFSRatio`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `OneMergeWrappingMergePolicy(MergePolicy in, UnaryOperator<MergePolicy.OneMerge> wrapOneMerge)`
  Constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MergePolicy.MergeSpecification`
  `findForcedDeletesMerges(SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext)`
  Determine what set of merge operations is necessary in order to expunge all deletes from the index.
  `MergePolicy.MergeSpecification`
  `findForcedMerges(SegmentInfos segmentInfos, int maxSegmentCount, Map<SegmentCommitInfo,Boolean> segmentsToMerge, MergePolicy.MergeContext mergeContext)`
  Determine what set of merge operations is necessary in order to merge to `<=` the specified segment count.
  `MergePolicy.MergeSpecification`
  `findFullFlushMerges(MergeTrigger mergeTrigger, SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext)`
  Identifies merges that we want to execute (synchronously) on commit.
  `MergePolicy.MergeSpecification`
  `findMerges(MergeTrigger mergeTrigger, SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext)`
  Determine what set of merge operations are now necessary on the index.

  ### Methods inherited from class org.apache.lucene.index.FilterMergePolicy

  `findMerges, getMaxCFSSegmentSizeMB, getNoCFSRatio, keepFullyDeletedSegment, maxFullFlushMergeSize, numDeletesToMerge, setMaxCFSSegmentSizeMB, setNoCFSRatio, size, toString, unwrap, useCompoundFile`

  ### Methods inherited from class org.apache.lucene.index.MergePolicy

  `assertDelCount, isMerged, message, segString, verbose`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### OneMergeWrappingMergePolicy

    public OneMergeWrappingMergePolicy(MergePolicy in, UnaryOperator<MergePolicy.OneMerge> wrapOneMerge)
    Constructor
    Parameters:
      `in` - - the wrapped merge policy
      `wrapOneMerge` - - operator for wrapping OneMerge objects

- ## Method Details

  - ### findMerges

    public MergePolicy.MergeSpecification findMerges(MergeTrigger mergeTrigger, SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext) throws IOException
    Description copied from class: `MergePolicy`
    Determine what set of merge operations are now necessary on the index. `IndexWriter` calls this whenever there is a change to the segments. This call is always synchronized on the `IndexWriter` instance so only one thread at a time will call this method.
    Overrides:
      `findMerges` in class `FilterMergePolicy`
    Parameters:
      `mergeTrigger` - the event that triggered the merge
      `segmentInfos` - the total set of segments in the index
      `mergeContext` - the IndexWriter to find the merges on
    Throws:
      `IOException`

  - ### findForcedMerges

    public MergePolicy.MergeSpecification findForcedMerges(SegmentInfos segmentInfos, int maxSegmentCount, Map<SegmentCommitInfo,Boolean> segmentsToMerge, MergePolicy.MergeContext mergeContext) throws IOException
    Description copied from class: `MergePolicy`
    Determine what set of merge operations is necessary in order to merge to `<=` the specified segment count. `IndexWriter` calls this when its `IndexWriter.forceMerge(int)` method is called. This call is always synchronized on the `IndexWriter` instance so only one thread at a time will call this method.
    Overrides:
      `findForcedMerges` in class `FilterMergePolicy`
    Parameters:
      `segmentInfos` - the total set of segments in the index
      `maxSegmentCount` - requested maximum number of segments in the index
      `segmentsToMerge` - contains the specific SegmentInfo instances that must be merged away. This may be a subset of all SegmentInfos. If the value is True for a given SegmentInfo, that means this segment was an original segment present in the to-be-merged index; else, it was a segment produced by a cascaded merge.
      `mergeContext` - the MergeContext to find the merges on
    Throws:
      `IOException`

  - ### findForcedDeletesMerges

    public MergePolicy.MergeSpecification findForcedDeletesMerges(SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext) throws IOException
    Description copied from class: `MergePolicy`
    Determine what set of merge operations is necessary in order to expunge all deletes from the index.
    Overrides:
      `findForcedDeletesMerges` in class `FilterMergePolicy`
    Parameters:
      `segmentInfos` - the total set of segments in the index
      `mergeContext` - the MergeContext to find the merges on
    Throws:
      `IOException`

  - ### findFullFlushMerges

    public MergePolicy.MergeSpecification findFullFlushMerges(MergeTrigger mergeTrigger, SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext) throws IOException
    Description copied from class: `MergePolicy`
    Identifies merges that we want to execute (synchronously) on commit. By default, this will return `natural merges` whose segments are all less than the `max segment size for full flushes`.

    Any merges returned here will make `IndexWriter.commit()`, `IndexWriter.prepareCommit()` or `IndexWriter.getReader(boolean, boolean)` block until the merges complete or until `LiveIndexWriterConfig.getMaxFullFlushMergeWaitMillis()` has elapsed. This may be used to merge small segments that have just been flushed, reducing the number of segments in the point in time snapshot. If a merge does not complete in the allotted time, it will continue to execute, and eventually finish and apply to future point in time snapshot, but will not be reflected in the current one.

    If a `MergePolicy.OneMerge` in the returned `MergePolicy.MergeSpecification` includes a segment already included in a registered merge, then `IndexWriter.commit()` or `IndexWriter.prepareCommit()` will throw a `IllegalStateException`. Use `MergePolicy.MergeContext.getMergingSegments()` to determine which segments are currently registered to merge.

    Overrides:
      `findFullFlushMerges` in class `FilterMergePolicy`
    Parameters:
      `mergeTrigger` - the event that triggered the merge (COMMIT or GET_READER).
      `segmentInfos` - the total set of segments in the index (while preparing the commit)
      `mergeContext` - the MergeContext to find the merges on, which should be used to determine which segments are already in a registered merge (see `MergePolicy.MergeContext.getMergingSegments()`).
    Throws:
      `IOException`